blob: f24c7f2d23c13e9874308a019f3c0f93225de3c0 [file] [log] [blame]
Linus Torvaldsb33e9662005-07-08 10:57:21 -07001#!/bin/sh
2#
Junio C Hamanoae2b0f12005-11-24 00:12:11 -08003# This is included in commands that either have to be run from the toplevel
4# of the repository, or with GIT_DIR environment variable properly.
5# If the GIT_DIR does not look like the right correct git-repository,
6# it dies.
Linus Torvaldsb33e9662005-07-08 10:57:21 -07007
Junio C Hamano365527a2005-09-12 19:47:07 -07008# Having this variable in your environment would break scripts because
9# you would cause "cd" to be be taken to unexpected places. If you
10# like CDPATH, define it for your interactive shell sessions without
11# exporting it.
12unset CDPATH
13
Linus Torvaldsb33e9662005-07-08 10:57:21 -070014die() {
Junio C Hamano8098a172005-09-30 14:26:57 -070015 echo >&2 "$@"
Linus Torvaldsb33e9662005-07-08 10:57:21 -070016 exit 1
17}
18
Fredrik Kuivinend0255242005-12-11 10:55:49 +010019usage() {
20 die "Usage: $0 $USAGE"
21}
22
Shawn O. Pearcef9474132006-12-28 02:34:48 -050023set_reflog_action() {
24 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
25 then
26 GIT_REFLOG_ACTION="$*"
27 export GIT_REFLOG_ACTION
28 fi
29}
30
Junio C Hamano4b441f42007-01-07 02:17:52 -080031is_bare_repository () {
Tom Princee0d10e12007-01-28 16:16:53 -080032 git-config --bool --get core.bare ||
Junio C Hamano4b441f42007-01-07 02:17:52 -080033 case "$GIT_DIR" in
34 .git | */.git) echo false ;;
35 *) echo true ;;
36 esac
37}
38
Junio C Hamano9fde9402007-01-12 12:44:08 -080039cd_to_toplevel () {
40 cdup=$(git-rev-parse --show-cdup)
41 if test ! -z "$cdup"
42 then
43 cd "$cdup" || {
44 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
45 exit 1
46 }
47 fi
48}
49
Shawn O. Pearce7eff28a2006-12-30 23:32:38 -050050require_work_tree () {
Johannes Schindelin6d9ba672007-01-23 13:30:20 +010051 test $(is_bare_repository) = false &&
52 test $(git-rev-parse --is-inside-git-dir) = false ||
Shawn O. Pearce7eff28a2006-12-30 23:32:38 -050053 die "fatal: $0 cannot be used without a working tree."
54}
55
Fredrik Kuivinend0255242005-12-11 10:55:49 +010056if [ -z "$LONG_USAGE" ]
57then
58 LONG_USAGE="Usage: $0 $USAGE"
59else
60 LONG_USAGE="Usage: $0 $USAGE
61
62$LONG_USAGE"
63fi
64
65case "$1" in
Junio C Hamanocad1ed92006-04-14 15:54:51 -070066 -h|--h|--he|--hel|--help)
Fredrik Kuivinend0255242005-12-11 10:55:49 +010067 echo "$LONG_USAGE"
68 exit
69esac
70
Junio C Hamanoc8769f72006-08-11 18:47:50 -070071# Make sure we are in a valid repository of a vintage we understand.
Fredrik Kuivinend0255242005-12-11 10:55:49 +010072if [ -z "$SUBDIRECTORY_OK" ]
73then
74 : ${GIT_DIR=.git}
Junio C Hamano120b0df2007-01-12 12:24:16 -080075 GIT_DIR=$(GIT_DIR="$GIT_DIR" git-rev-parse --git-dir) || {
76 exit=$?
77 echo >&2 "You need to run this command from the toplevel of the working tree."
78 exit $exit
79 }
Fredrik Kuivinend0255242005-12-11 10:55:49 +010080else
81 GIT_DIR=$(git-rev-parse --git-dir) || exit
82fi
Junio C Hamanoc8769f72006-08-11 18:47:50 -070083: ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}